#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle interactive servers definition 
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

from string import *

from Tkinter import *

import Pmw

import lib.utils
from lib.ServerDef import *

from ServerEditor import *

class ServersEditor :
	"""Handle interactive servers definition"""

	# Generic methods
	#--------------------------------------------
	def __init__(self, top):
		self.top= top
		self.servers={}
		self._initGUI(top)

	# Public methods
	#--------------------------------------------
	def Clean(self):
		for server in self.servers.keys():
			self.servers[server].Delete()

	def Delete(self):
		self._delGUI()

	def AddServer(self):
		id= lib.utils.getuniqueid()
		self.servers[id]=ServerEditor(self,self.wfservers,id)
		return self.servers[id]

	# Internal GUI methods
	#--------------------------------------------
	def _addserver(self):
		id= lib.utils.getuniqueid()
		self.servers[id]=ServerEditor(self,self.wfservers,id)

	def _delserver(self,id):
		del self.servers[id]

	def _delGUI(self):
		self.wf.destroy()

	def _initGUI(self,top):
		self.wf= Frame(top, relief="raised")
		self.wf.pack(side="top", fill="both", expand="yes")
		self.balloon = Pmw.Balloon(self.wf)

		# Servers frame
		sf=Pmw.ScrolledFrame(self.wf, usehullsize = 1, hull_width= 300, hull_height= 200)
		sf.pack(side="top", fill="both", expand="yes")
		self.wfservers=sf.interior()

		# Button area
		f=Frame(self.wf)
		b=Button(f,text="Add server",command=self._addserver)
		b.pack(side="left", expand="no")
		self.balloon.bind(b, 'Add a server')
		f.pack(side="bottom", fill="x", expand="no")
		
