#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle interactive parameters definition 
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

from string import *

from Tkinter import *

import Pmw

import lib.utils
from lib.ParameterDef import *

from ParameterEditor import *

class ParametersEditor :
	"""Handle interactive parameters definition"""

	# Generic methods
	#--------------------------------------------
	def __init__(self, top):
		self.top= top
		self.parameters={}
		self._initGUI(top)

	# Public methods
	#--------------------------------------------
	def Clean(self):
		for parameter in self.parameters.keys():
			self.parameters[parameter].Delete()

	def Delete(self):
		self._delGUI()

	def AddParameter(self):
		id= lib.utils.getuniqueid()
		self.parameters[id]=ParameterEditor(self,self.wfparameters,id)
		return self.parameters[id]

	# Internal GUI methods
	#--------------------------------------------
	def _addparameter(self):
		id= lib.utils.getuniqueid()
		self.parameters[id]=ParameterEditor(self,self.wfparameters,id)

	def _delparameter(self,id):
		del self.parameters[id]

	def _delGUI(self):
		self.wf.destroy()

	def _initGUI(self,top):
		self.wf= Frame(top, relief="raised")
		self.wf.pack(side="top", fill="both", expand="yes")
		self.balloon = Pmw.Balloon(self.wf)

		# Ports frame
		sf=Pmw.ScrolledFrame(self.wf, usehullsize = 1, hull_width= 300, hull_height= 200)
		sf.pack(side="top", fill="both", expand="yes")
		self.wfparameters=sf.interior()

		# Button area
		f=Frame(self.wf)
		b=Button(f,text="Add parameter",command=self._addparameter)
		b.pack(side="left", expand="no")
		self.balloon.bind(b, 'Add a parameter')
		f.pack(side="bottom", fill="x", expand="no")
		
