#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle interactive port type definition and port type selection
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

from Tkinter import *
import Pmw

def AddPortType(newtype):
	global globaltypelistbox
	for porttype in globaltypelistbox.get(0,"end") :
		if porttype == newtype:
			return
	globaltypelistbox.insert("end",newtype)

def SetPortType(top,e,tkvar):
	global globaltypelistbox

	popup=Menu(top)
	for porttype in globaltypelistbox.get(0,"end") :
		popup.add_command(label=porttype,command=lambda tkvar=tkvar, type=porttype: tkvar.set(type))
	popup.post(e.x_root,e.y_root)
	popup.grab_set()
	popup.mainloop()

class PortTypeEditor :
	"""Handle interactive port type definition"""

	_bgcolor= "#555555"		# PortTypeEditor background color

	# Generic methods
	#--------------------------------------------
	def __init__(self, top):
		self.top= top
		self._initGUI(top)

	# Public methods
	#--------------------------------------------

	# Internal GUI methods
	#--------------------------------------------
	def _delGUI(self):
		self.wf.destroy()

	def _initGUI(self,top):
		global globaltypelistbox
		self.wf= Frame(top, background=self._bgcolor)
		self.balloon = Pmw.Balloon(self.wf)
		self.wcb=Pmw.ComboBox(self.wf,label_text="Port types",labelpos="w")
		globaltypelistbox= self.wcb.component('scrolledlist').component('listbox')
		self.wcb.pack(side="left",fill="x",expand="yes",  padx="5", pady="5")
		self.balloon.bind(self.wcb, 'Add new port types in this entry')
		self.wf.pack(side="top",fill="x", expand="no",padx="5",pady="5")

