#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle interactive ports definition 
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

from string import *

from Tkinter import *
from FileDialog import *
from tkSimpleDialog import *

import Pmw

import lib.utils
from lib.PortDef import *

from PortEditor import *

class PortsEditor :
	"""Handle interactive ports definition"""

	# Generic methods
	#--------------------------------------------
	def __init__(self, top):
		self.top= top
		self.ports={}
		self._initGUI(top)

	# Public methods
	#--------------------------------------------
	def Clean(self):
		for port in self.ports.keys():
			self.ports[port].Delete()
			
	def Delete(self):
		self._delGUI()


	# Internal GUI methods
	#--------------------------------------------
	def _delport(self,id):
		del self.ports[id]

	def _delGUI(self):
		self.wf.destroy()

	def _initGUI(self,top):
		self.wf= Frame(top, relief="raised")
		self.wf.pack(side="top", fill="both", expand="yes")
		self.balloon = Pmw.Balloon(self.wf)

		# Ports frame
		sf=Pmw.ScrolledFrame(self.wf, usehullsize = 1, hull_width= 300, hull_height= 200)
		sf.pack(side="top", fill="both", expand="yes")
		self.wfports=sf.interior()

		# Button area
		f=Frame(self.wf)
		b=Button(f,text="Add port",command=self._addport)
		b.pack(side="left", expand="no")
		self.balloon.bind(b, 'Add a port')
		f.pack(side="bottom", fill="x", expand="no")
		
class InputPortsEditor(PortsEditor):
	def AddPort(self):
		id= lib.utils.getuniqueid()
		self.ports[id]=InputPortEditor(self,self.wfports,id)
		return self.ports[id]
	def _addport(self):
		id= lib.utils.getuniqueid()
		self.ports[id]=InputPortEditor(self,self.wfports,id)
		
class OutputPortsEditor(PortsEditor):
	def AddPort(self):
		id= lib.utils.getuniqueid()
		self.ports[id]=OutputPortEditor(self,self.wfports,id)
		return self.ports[id]
	def _addport(self):
		id= lib.utils.getuniqueid()
		self.ports[id]=OutputPortEditor(self,self.wfports,id)

