#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle interactive server definition 
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

from string import *

from Tkinter import *
import Pmw

from lib.ServerDef import *

class ServerEditor :
	"""Handle interactive server definition"""

	_bgcolor= "#5555ff"		# ServerEditor background color

	# Generic methods
	#--------------------------------------------
	def __init__(self, serverseditor, top, id):
		self.serverseditor= serverseditor
		self.top= top
		self.id= id
		self._initGUI(top)

	# Public methods
	#--------------------------------------------
	def Delete(self):
		"""Delete server"""
		self.serverseditor._delserver(self.id)
		self._delGUI()

	def SetServerDef(self,serverdef):
		self.vtype.set(serverdef.type)
		self.vdesc.set(serverdef.desc)

	def GetServerDef(self):
		type= self.vtype.get()
		desc= self.vdesc.get()
		s= ServerDef(type,desc)
		return s

	# Internal GUI methods
	#--------------------------------------------
	def _delGUI(self):
		self.wf.destroy()

	def _initGUI(self,top):
		self.wf= Frame(top, relief="raised",background=self._bgcolor)
		self.wf.pack(side="top", fill="both", expand="yes", padx="2", pady="2")
		self.balloon = Pmw.Balloon(self.wf)

		f=Frame(self.wf,background=self._bgcolor)

		Label(f,text="Type",background=self._bgcolor).pack(side="left")
		self.vtype= StringVar()
		e=Entry(f,textvariable=self.vtype)
		e.pack(side="left",fill="x",expand="yes")
		self.balloon.bind(e, 'Enter server type')

		b=Button(f,text="Delete",command=self.Delete)
		b.pack(side="right", expand="no",  padx="5", pady="5")
		self.balloon.bind(b, 'Delete this server')
		f.pack(side="top",fill="x",expand="yes", padx="5", pady="5")
		
		f=Frame(self.wf,background=self._bgcolor)
		l=Label(f,text="Description",background=self._bgcolor)
		l.pack(side="left")
		self.vdesc= StringVar()
		e=Entry(f,textvariable=self.vdesc)
		e.pack(side="left",fill="x",expand="yes",  padx="5", pady="5")
		self.balloon.bind(e, 'Comment associated to this server')

		f.pack(side="bottom",fill="x",expand="yes", padx="5", pady="5")

