#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle interactive frontend for factory code generation
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

import sys, re, string

from Tkinter import *
from FileDialog import *
from tkSimpleDialog import *
import Pmw

from lib.PortDef import *
from lib.ParameterDef import *
from lib.ActionDef import *
from lib.FactoryDef import *

import Generation

class FactoryGenerator:
	"""Handle factory code generation"""
	
	def __init__(self, top):
		self.top= top
		self._initGUI(top)


	# Internal methods
	#----------------------------------------------
	def Generate(self):
		dirname=string.strip(self.vdirname.get())
		Generation.Generate(self.factorydef,dirname)
		self.wgenerate.configure(background="#00ff00")
		
	# Internal GUI methods
	#----------------------------------------------
	def _loadfromref(self):
		file= FileDialog(self.top).go()
		if file is None:
			print "Unable to open action factory specification"
		else:
			fid=open(file,'r')
			x= FactoryDefXMLParser()
			while 1:
				l= fid.readline()
				if l=="":
					break
				x.feed(l)
			fid.close()

			if len(x.factories) == 1:
				for factoryname in x.factories.keys():
					self.factorydef= x.factories[factoryname]
				self.vfactoryname.set(self.factorydef.name)
				self.wgenerate.configure(background="#aaaaaa")
			else:
				print "File ",file," contains no or more than 1 factory description"
				print "Generation is only operationnal on 1 single factory description"

			x.close()
			del x
		
	def _initGUI(self, top):
		f=Frame(top)
		Label(f,text="Action factory").pack(side="left", fill="x",expand="no")
		self.vfactoryname=StringVar()
		self.vfactoryname.set("")
		Label(f,textvariable=self.vfactoryname,foreground="#ff0000").pack(side="left",fill="x", expand="no")
		Button(f, text="Load factory desc", command= self._loadfromref).pack(side="right", expand="no")
		f.pack(side="top",fill="x",expand="no")
		
		f=Frame(top)
		Label(f,text="Generation directory").pack(side="left", expand="no")
		self.vdirname=StringVar()
		self.vdirname.set("")
		Entry(f,textvariable=self.vdirname).pack(side="left",fill="x", expand="yes")
		f.pack(side="top",fill="x",expand="no")

		self.wgenerate=Button(top, text="Generate C++", command=self.Generate)
		self.wgenerate.pack(side="bottom")
		
		
