#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle the links GUI and associated datas
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

from Tkinter import *

gnum=0

class LinkLine:
	"""Handle the links GUI and associated datas"""

	def __init__(self, mapeditor, actionBoxIn, portnameIn, actionBoxOut, portnameOut):
		global gnum
		self.num= gnum
		gnum= gnum + 1

		self.mapeditor= mapeditor

		self.ActionBoxIn= actionBoxIn			# "in" for the link
		self.PortnameIn= portnameIn
		self.ActionBoxIn.RegisterOutLink(self)	# means it's getting "out" from actionboxin

		self.ActionBoxOut= actionBoxOut			# "out" for the link
		self.PortnameOut= portnameOut
		self.ActionBoxOut.RegisterInLink(self)	# means it's getting "in" into actionboxout

		self._initGUI(mapeditor.wcanvas)

		mapeditor.RegisterLink(self)

	def __del__(self):
		self.mapeditor.UnregisterLink(self)
		self.ActionBoxIn.UnregisterOutLink(self)
		self.ActionBoxOut.UnregisterInLink(self)
		return "Deleting link " + self.ActionBoxIn.actiondef.name + " - " + self.ActionBoxOut.actiondef.name
	
	def __repr__(self):
		return "Link " + self.ActionBoxIn.actiondef.name + "." + self.PortnameIn + " -> " + self.ActionBoxOut.actiondef.name + "." + self.PortnameOut

	# Execution model
	#-------------------------------------
	def Transmit(self,value):
		if self.mapeditor.globalvars.status:
			print self.ActionBoxIn.actiondef.name," to ",self.ActionBoxOut.actiondef.name," link > Transmitting ",value, " to port ",self.PortnameOut
		else:
			print "*** Warning, a global test is false !!! ***"
			self.mapeditor.firemode= "manual"
			print self.ActionBoxIn.actiondef.name," to ",self.ActionBoxOut.actiondef.name," link > Transmission  forced of ",value, " to port ",self.PortnameOut
		self.ActionBoxOut.SetInputPort(self.PortnameOut,value)


	# GUI related methods
	#-------------------------------------
	def _initGUI(self,wcanvas):
		self.id=wcanvas.create_line(self.ActionBoxIn.x+50,self.ActionBoxIn.y,self.ActionBoxOut.x-50,self.ActionBoxOut.y)	
		wcanvas.tag_bind(self.id,"<ButtonPress-1>",self.Destroy)

	def Update(self):
		self.mapeditor.wcanvas.coords(self.id,self.ActionBoxIn.x+50,self.ActionBoxIn.y,self.ActionBoxOut.x-50,self.ActionBoxOut.y)

	def Destroy(self,e=None):
		self.mapeditor.wcanvas.delete(self.id) 
		self.__del__()


class GroupInLink(LinkLine):

	def __init__(self, mapeditor, groupIn, portnameIn, actionBoxOut, portnameOut):
		global gnum
		self.num= gnum
		gnum= gnum + 1

		self.mapeditor= mapeditor

		self.ActionBoxIn= groupIn			# "in" for the link
		self.PortnameIn= portnameIn

		self.ActionBoxOut= actionBoxOut			# "out" for the link
		self.PortnameOut= portnameOut
		self.ActionBoxOut.RegisterInLink(self)	# means it's getting "in" into actionboxout

		self._initGUI(mapeditor.wcanvas)

		mapeditor.RegisterLink(self)

	def _initGUI(self,wcanvas):
		self.id=wcanvas.create_line(self.ActionBoxOut.x-150,self.ActionBoxOut.y,self.ActionBoxOut.x-50,self.ActionBoxOut.y)	
		wcanvas.tag_bind(self.id,"<ButtonPress-1>",self.Destroy)

	def Update(self):
		self.mapeditor.wcanvas.coords(self.id,self.ActionBoxOut.x-150,self.ActionBoxOut.y,self.ActionBoxOut.x-50,self.ActionBoxOut.y)


class GroupOutLink(LinkLine):

	def __init__(self, mapeditor, actionBoxIn, portnameIn, groupOut, portnameOut):
		global gnum
		self.num= gnum
		gnum= gnum + 1

		self.mapeditor= mapeditor

		self.ActionBoxIn= actionBoxIn			# "in" for the link
		self.PortnameIn= portnameIn
		self.ActionBoxIn.RegisterOutLink(self)	# means it's getting "out" from actionboxin

		self.ActionBoxOut= groupOut			# "out" for the link
		self.PortnameOut= portnameOut

		self._initGUI(mapeditor.wcanvas)

		mapeditor.RegisterLink(self)

	def Transmit(self,value):
		if self.mapeditor.globalvars.status:
			print self.ActionBoxIn.actiondef.name," to ",self.ActionBoxOut.actiondef.name," link > Transmitting ",value, " to port ",self.PortnameOut
			self.ActionBoxOut.SetOutputPort(self.PortnameOut,value)
		else:
			print self.ActionBoxIn.actiondef.name," to ",self.ActionBoxOut.actiondef.name," link > Transmission stopped because global test failed"
	def _initGUI(self,wcanvas):
		self.id=wcanvas.create_line(self.ActionBoxIn.x+50,self.ActionBoxIn.y,self.ActionBoxIn.x+150,self.ActionBoxIn.y)	
		wcanvas.tag_bind(self.id,"<ButtonPress-1>",self.Destroy)

	def Update(self):
		self.mapeditor.wcanvas.coords(self.id,self.ActionBoxIn.x+50,self.ActionBoxIn.y,self.ActionBoxIn.x+150,self.ActionBoxIn.y)
