#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle direct system command execution on input trigger
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 
import os, sys

from Tkinter import *
from FileDialog import *
from tkSimpleDialog import *
import Pmw

import lib.utils
from lib.PortDef import *
from lib.ParameterDef import *
from lib.ActionDef import *

from GlobalVars import *
from LinkLine import *
from ActionBox import *
from ParameterBox import *

from string import *
import re

class CommandBox(ParameterBox):
	"""Handle direct system command on input trigger"""

	# Generic methods
	#-------------------------------------
	def __init__(self, mapeditor, x, y, name="CommandAction"):
		self.num= lib.utils.getuniqueid()

		self.mapeditor= mapeditor
		self.x= x
		self.y= y
		
		self.actiondef= ActionDef(name,"commandaction")
		self.inports={}
		self.invalues={}
		self.inports["*"]=[]
		self.invalues["*"]=[]
		self.outports={}
		self.outports["*"]=[]
		
		self._initGUI(mapeditor,self.actiondef)

		mapeditor.RegisterAction(self)

	def _trigger(self):
		order= self._buildorder()
		if order is not None:
			print order
			try:
				os.system(order)
			except:
				print "Error: unable to execute your order properly"
			
	def _buildorder(self):
		order=self.vparamaction.get()
		print "buildorder: initial order is : ",order
		try:
			for globalvar in self.mapeditor.globalvars.vars.values():
				oldstring= globalvar.name
				newstring= self.mapeditor.globalvars.vars[globalvar.name].get()
				neworder=replace(order,oldstring,newstring)
				print "                new order is : ",neworder
			return neworder
		except:
			print "Error : unable to translate your order"
			return None


	# Internal GUI related methods
	#-------------------------------------
	def _rename(self,e):
		prompt= "Enter a new name for commandaction "+self.vname.get()
		newname= askstring("New CommandAction name", prompt)
		self.vname.set(newname)
		self.actiondef.name=newname
