#=========================================================================================
#@(#)Thierry: $Id$
#
#    Handle the global variables in a map editor
#
#-----------------------------------------------------------------------------------------
#                                                                         
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   (C) 2000 by Thierry CHEVALIER <t_chevalier@libertysurf.fr>
#
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

from Tkinter import *
import Pmw

class GlobalVar:
	"""Handle the global variables in a map editor"""

	def __init__(self,globalvars,top,name,value):
		self.globalvars=globalvars
		self.name= name
		self.ref=0
		self.vvaluetracecb= None
		self.tvaluetracecb= None
		self._initGUI(top,value)
		self.status=1

	def reference(self):
		self.ref= self.ref + 1
		print '  ref count for ',self.name,' is now ',str(self.ref)

	def unreference(self):
		self.ref= self.ref - 1
		print '  ref count for ',self.name,' is now ',str(self.ref)
		if self.ref <= 0:
			self.wf.destroy()
			return 1
		else:
			return 0

	def testok(self):
		self.wf.configure(background="#55ff55")
		self.wname.configure(background="#55ff55")
		self.status=1
	def testnotok(self):
		self.wf.configure(background="#ff5555")
		self.wname.configure(background="#ff5555")
		self.status=0

	def dotest(self,dummy1="bid",dummy2="bid",dummy3="bid"):
		teststring= self.vvalue.get() + self.ovalue.get() + self.tvalue.get()
		try:
			if eval(teststring):
				self.testok()
			else:
				self.testnotok()
		except:
			self.testnotok()
		self.globalvars.check_status()

	def settest(self,value):
		if value==' ':
			if self.vvaluetracecb is not None:
				self.wtvalue.pack_forget()
				self.vvalue.trace_vdelete("w",self.vvaluetracecb)
				self.vvaluetracecb= None
				self.tvalue.trace_vdelete("w",self.tvaluetracecb)
				self.tvaluetracecb= None
				self.wf.configure(background="#aaaaaa")
				self.wname.configure(background="#aaaaaa")
				self.status=1
		else:
			if self.vvaluetracecb is None:
				self.wtvalue.pack(side="left",fill="x",expand="yes")
				self.vvaluetracecb= self.vvalue.trace_variable("w",self.dotest)
				self.tvaluetracecb= self.tvalue.trace_variable("w",self.dotest)
				self.dotest()
			
	def set(self,value):
		self.vvalue.set(value)
	def get(self):
		return self.vvalue.get()
		
	def _initGUI(self,top,value):
		self.top=top

		self.wf=Frame(top,background="#aaaaaa")

		self.wname= Label(self.wf,text=self.name,background="#aaaaaa")
		self.wname.pack(side="left")

		self.vvalue=StringVar()
		self.vvalue.set(value)
		self.wvalue=Entry(self.wf,textvariable=self.vvalue)
		self.wvalue.pack(side="left",fill="x",expand="yes")

		self.ovalue=StringVar()
		self.ovalue.set(' ')
		Pmw.OptionMenu(
			self.wf,
			command=self.settest,
			menubutton_textvariable = self.ovalue,
			items = [' ', '<', '>', '<=', '>=', '==', '<>', '!=', 'is', 'is not', 'in', 'not in']
		).pack(side="left", expand="no")

		self.tvalue=StringVar()
		self.wtvalue=Entry(self.wf,textvariable=self.tvalue)

		self.wf.pack(side="top",fill="x",expand="yes")

class GlobalVars:

	def __init__(self,mapeditor,top):
		self.mapeditor= mapeditor
		self.vars={}
		self.status=1
		self._initGUI(top)

	def check_status(self):
		for var in self.vars.values():
			if not var.status:
				self.status=0
				self.mapeditor.SetManualFiremode()
				break
		else:
			self.status=1
		
	def subscribe(self,name,value):
		print 'Subscribing ',name
		if self.vars.has_key(name)==0:
			self.vars[name]=GlobalVar(self,self.frame.interior(),name,value)
		self.vars[name].reference()
		return self.vars[name].vvalue

	def unsubscribe(self,name):
		print 'Unsubscribing ',name
		if self.vars.has_key(name):
			if self.vars[name].unreference():
				del self.vars[name]
		else:
			print "WARNING: unsubscribing a non-existing global variable"
		
	def _initGUI(self,top):
		self.top= top
		Label(self.top,text="Global variables").pack(side="top",fill="x",expand="no")
		self.frame=Pmw.ScrolledFrame(top,usehullsize = 1,hull_height="150")
		self.frame.pack(side="top",fill="both",expand="yes")

        

