#=========================================================================================
#@(#)Thierry: $Id$ - ParamFile
#
#    Handle parameter file storage selection
#	 Either using a local filename or forwarding to father element
#
# (C) 2000 by Dassault Aviation <thierry.chevalier@dassault-aviation.fr>
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

from Tkinter import *
import Pmw
from FileDialog import *
from tkSimpleDialog import *

from string import *
import re

class ParamFile :

	# Generic methods
	#--------------------------------------------
	def __init__(self,paramlist,top,isroot):
		self.paramlist= paramlist
		self.isroot= isroot
		self._initGUI(top,isroot)

	def __del__(self):
		self.Delete()

	# Public methods
	#--------------------------------------------
	def Delete(self):
		self.wf.destroy()

	def Load(self,fid,tag):
		while 1:
	 		l= fid.readline()
			if l=="":
				break
			elif string.find(l,"%") != -1:
				try:
					(name,)=re.match("^[ ]*%(.*)[ ]*$",l).groups() 
				except:
					print "ignoring line >>>",l
					continue

				if (name==tag):
					return
				else:
					self.paramlist.AddSublistFromFile(strip(name),fid)
			else:
				try:
					(name,value)=re.match("^[ ]*([^=]*)[ ]*=[ ]*(.*)[ ]*$",l).groups() 
				except:
					print "ignoring line >>>",l
					continue
				
				self.paramlist.AddParameter(strip(name),strip(value))

	def Save(self,fid):
		self.paramlist.Save(fid)

	# Internal GUI methods
	#--------------------------------------------
	def _load(self):
		file= LoadFileDialog(self.top).go(pattern="*")
		if file is None:
			print "Unable to load paramlist, no filename provided"
		else:
			self.vfilename.set(file)
			print "=================== Paramlist reading for ", file, " =================="
			fid=open(file,'r')
			self.Load(fid,"")
			fid.close()
			print "=============== End of Paramlist reading for ", file, " ==============="

	def _save(self):
		file= SaveFileDialog(self.top).go(pattern="*")
		if file is None:
			print "Unable to save paramlist, no filename provided"
		else:
			self.vfilename.set(file)
			print "=================== Paramlist saving for ", file, " =================="
			fid=open(file,'w')
			self.Save(fid)
			fid.close()
			print "=============== End of Paramlist saving for ", file, " ==============="

	def _select(self):
		if self.vselect.get()=="local":
			self.wfilef.pack(side="top", fill="x", expand="yes")
		else:
			self.wfilef.pack_forget()
		
	def _initGUI(self,top,isroot):
		self.top= top
		# Global object frame
		self.wf= Frame(top, relief="sunken")
		self.wf.pack(side="top", fill="x", expand="no")
		# Inheritance/Local filename selection checkbox
		self.vselect= StringVar()
		if (not isroot):
			self.vselect.set("inherit")
			self.wselect= Checkbutton(self.wf, 	text="Inherit storage file", variable=self.vselect,
												onvalue="inherit", offvalue="local",
												command=self._select)
			self.wselect.pack(side="top")
		else:
			self.vselect.set("local")
		# Filename selection frame
		self.wfilef=Frame(self.wf, relief="sunken")
		self.vfilename= StringVar()
		l= Label(self.wfilef, textvariable=self.vfilename)
		l.pack(side="left",expand="no")
		b=Button(self.wfilef, text="Load", command=self._load)
		b.pack(side="right")
		b=Button(self.wfilef, text="Save", command=self._save)
		b.pack(side="right")
		if (isroot):
			self.wfilef.pack(side="top", fill="x", expand="yes")

