#=========================================================================================
#@(#)Thierry: $Id$ - Table
#
#    Tabular value viewer
#
# (C) 2000 by Dassault Aviation <thierry.chevalier@dassault-aviation.fr>
#-----------------------------------------------------------------------------------------
#$Log$
#-----------------------------------------------------------------------------------------
# Do list:
#========================================================================================= 

import Tkinter
import Pmw
import string

from FileDialog import *
from tkSimpleDialog import *

	
class Table:

	def __init__(self, top, X, Ynames, Yvals):
	
		self.top= top
	
		self._numElements= len(Yvals)
		self._names= Ynames
		self._vector_x = X
		self._vector_y = Yvals
		
		self._initGUI(top)
		
	def destroy(self):
		self._w.destroy()

	def _dumpASCII(self):
		lines= self._wvarlist.getcurselection() 
		file= SaveFileDialog(self.top).go(pattern="*")
		if file is None:
			print "Unable to properly dump to file, no filename provided"
		else:
			fid=open(file,'w')
			for line in lines:
				s= "%s\n"%(line)   
				fid.write(s)
		
	# Initialize GUI
	#------------------------
	def _initGUI(self, top):
		self._w= Tkinter.Frame(top)
		
		self._wvarlist=Pmw.ScrolledListBox(self._w)
		self._wvarlist.component('listbox').configure(selectmode="extended")
		self._wvarlist.pack(side="top",expand="yes", fill="both")
		Button(self._w,text="Dump ASCII",command=self._dumpASCII).pack(side="bottom",expand="no")

		l= self._wvarlist.component('listbox')
		# Dump first line = names
		line= "Tps recalcul   "
		for j in range(0,self._numElements):
			line= line + "    %16s"%(self._names[j])   
		l.insert("end",line)
		# Dump values
		for i in range(0,len(self._vector_x)):
			line= "%-16.4lf"%(self._vector_x[i])
			for j in range(0,self._numElements):
				line= line + "    %16.8lf"%(self._vector_y[j][i])  
			l.insert("end",line)
			
		self._w.pack(side="top", expand="yes", fill="both")
