#=========================================================================================
#@(#)Thierry: $Id$ - FactoryDef
#
#   A class to describe what's available within a factory
#
# (C) 2000 by Dassault Aviation <thierry.chevalier@dassault-aviation.fr>
#-----------------------------------------------------------------------------------------
#$Log$
#========================================================================================= 

from xmllib import *

from PortDef import *
from ParameterDef import *
from ActionDef import *

class FactoryDefParser(ActionDefParser):
	def __init__(self):
		ActionDefParser.__init__(self)
		self.factories={}

	def start_factorydef(self,attrs):
		try:
			self.f= FactoryDef(attrs["name"],attrs["desc"])
			self.factories[self.f.name]= self.f
			self.actions={}
		except:
			print "FactoryDefParser : action malformed attributes ",attrs

	def end_factorydef(self):
		self.f.actions=self.actions
		
class FactoryDefXMLParser(FactoryDefParser,XMLParser):
	def __init__(self):
		FactoryDefParser.__init__(self)
		XMLParser.__init__(self)

class FactoryDef:

	def __init__(self,name,desc=""):
		self.name=name
		self.desc=desc
		self.actions={}

	def __repr__(self):
		return self.name

	def AddAction(self, action):
		self.actions[action.name]= action

	def GetObjecttypenameList(self):
		objecttypelist=[]
		for action in self.actions.keys():
			for objecttypename in self.actions[action].GetObjecttypenameList():
				if not objecttypename in objecttypelist:
					objecttypelist.append(objecttypename)
		return objecttypelist
		
	def GetServertypeList(self):
		serverlist=[]
		for action in self.actions.keys():
			for servertype in self.actions[action].GetServertypeList():
				if not servertype in serverlist:
					serverlist.append(servertype)
		return serverlist

	def Save(self,fid,indent):
		s= "%s<factorydef name=\"%s\" desc=\"%s\" >\n"%(indent,self.name,self.desc)   
		fid.write(s)
		newindent= indent + "  "
		for action in self.actions.keys():
			self.actions[action].Save(fid,newindent)
		s= "%s</factorydef>\n"%(indent)   
		fid.write(s)
